## libsrtp2 2.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)

project(libsrtp2 VERSION 2.5.0 LANGUAGES C)

set(PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
set(PACKAGE_STRING "${CMAKE_PROJECT_NAME} ${CMAKE_PROJECT_VERSION}")

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

include(TestBigEndian)
include(CheckIncludeFile)
include(CheckFunctionExists)
include(CheckTypeSize)
include(CheckCSourceCompiles)

test_big_endian(WORDS_BIGENDIAN)

if (NOT APPLE AND CMAKE_SYSTEM_PROCESSOR MATCHES "(x86)|(X86)|(amd64)|(AMD64)")
  set (HAVE_X86 TRUE)
else ()
  set (HAVE_X86 FALSE)
endif ()

check_include_file(arpa/inet.h HAVE_ARPA_INET_H)
check_include_file(byteswap.h HAVE_BYTESWAP_H)
check_include_file(inttypes.h HAVE_INTTYPES_H)
check_include_file(machine/types.h HAVE_MACHINE_TYPES_H)
check_include_file(netinet/in.h HAVE_NETINET_IN_H)
check_include_file(stdint.h HAVE_STDINT_H)
check_include_file(stdlib.h HAVE_STDLIB_H)
check_include_file(sys/int_types.h HAVE_SYS_INT_TYPES_H)
check_include_file(sys/socket.h HAVE_SYS_SOCKET_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(unistd.h HAVE_UNISTD_H)
check_include_file(windows.h HAVE_WINDOWS_H)
check_include_file(winsock2.h HAVE_WINSOCK2_H)

check_function_exists(sigaction HAVE_SIGACTION)
check_function_exists(inet_aton HAVE_INET_ATON)
check_function_exists(inet_pton HAVE_INET_PTON)
check_function_exists(usleep HAVE_USLEEP)

check_type_size(uint8_t UINT8_T)
check_type_size(uint16_t UINT16_T)
check_type_size(uint32_t UINT32_T)
check_type_size(uint64_t UINT64_T)
check_type_size(int32_t INT32_T)
check_type_size("unsigned long" SIZEOF_UNSIGNED_LONG)
check_type_size("unsigned long long" SIZEOF_UNSIGNED_LONG_LONG)

check_c_source_compiles("inline void func(); void func() { } int main() { func(); return 0; }" HAVE_INLINE)
if(NOT HAVE_INLINE)
  check_c_source_compiles("__inline void func(); void func() { } int main() { func(); return 0; }" HAVE___INLINE)
endif()

set(ENABLE_DEBUG_LOGGING OFF CACHE BOOL "Enable debug logging in all modules")
set(ERR_REPORTING_STDOUT OFF CACHE BOOL "Enable logging to stdout")
set(ERR_REPORTING_FILE "" CACHE FILEPATH "Use file for logging")
set(ENABLE_OPENSSL OFF CACHE BOOL "Enable OpenSSL crypto engine")
set(ENABLE_MBEDTLS OFF CACHE BOOL "Enable MbedTLS crypto engine")
set(ENABLE_NSS OFF CACHE BOOL "Enable NSS crypto engine")
set(TEST_APPS ON CACHE BOOL "Build test applications")
set(BUILD_WITH_SANITIZERS OFF CACHE BOOL "Adds sanitizer flags to compiler")
set(BUILD_WITH_WARNINGS ON CACHE BOOL "Adds warnings and warning as error flags to compiler")
option(BUILD_SHARED_LIBS "Build shared library" OFF)

if(ENABLE_OPENSSL OR ENABLE_MBEDTLS OR ENABLE_NSS)
  set(USE_EXTERNAL_CRYPTO TRUE)
else()
  set(USE_EXTERNAL_CRYPTO FALSE)
endif()

if(ENABLE_OPENSSL)
  if(ENABLE_NSS OR ENABLE_MBEDTLS)
    message(FATAL_ERROR "ssl conflict. can not enable openssl and mbedtls or nss simultaneously.")
  endif()
  find_package(OpenSSL 1.1.0 REQUIRED)
  set(OPENSSL ${ENABLE_OPENSSL} CACHE BOOL INTERNAL)
  set(GCM ${ENABLE_OPENSSL} CACHE BOOL INTERNAL)
endif()

if(ENABLE_MBEDTLS)
  if(ENABLE_OPENSSL OR ENABLE_NSS)
    message(FATAL_ERROR "ssl conflict. can not enable mbedtls and openssl or nss simultaneously.")
  endif()
  find_package(MbedTLS REQUIRED)
  set(MBEDTLS ${ENABLE_MBEDTLS} CACHE BOOL INTERNAL)
  set(GCM ${ENABLE_MBEDTLS} CACHE BOOL INTERNAL)
endif()

if(ENABLE_NSS)
  if(ENABLE_OPENSSL OR ENABLE_MBEDTLS)
    message(FATAL_ERROR "ssl conflict. can not enable nss and openssl or mbedtls simultaneously.")
  endif()
  find_package(NSS REQUIRED)
  set(NSS ${ENABLE_NSS} CACHE BOOL INTERNAL)
  set(GCM ${ENABLE_NSS} CACHE BOOL INTERNAL)
endif()

set(CONFIG_FILE_DIR ${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CONFIG_FILE_DIR})

configure_file(config_in_cmake.h ${CONFIG_FILE_DIR}/config.h)
add_definitions(-DHAVE_CONFIG_H)

if(BUILD_WITH_SANITIZERS AND NOT WIN32)
  if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(SANITIZERS address,undefined)
  else()
    set(SANITIZERS leak,address,undefined)
  endif()
  message(STATUS "Using sanitizers: ${SANITIZERS}")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
endif()


if(BUILD_WITH_WARNINGS)
  if(CMAKE_C_COMPILER_ID MATCHES "Clang" OR CMAKE_C_COMPILER_ID MATCHES "GNU")
    set(WARNINGS -Wall -pedantic -Wextra -Werror)
  elseif(MSVC)
    set(WARNINGS /W4 /WX)
  endif()
  message(STATUS "Using warnings: ${WARNINGS}")
  add_compile_options(${WARNINGS})
endif()

set(SOURCES_C
  srtp/srtp.c
)

set(CIPHERS_SOURCES_C
  crypto/cipher/cipher.c
  crypto/cipher/cipher_test_cases.c
  crypto/cipher/cipher_test_cases.h
  crypto/cipher/null_cipher.c
)

if(ENABLE_OPENSSL)
  list(APPEND CIPHERS_SOURCES_C
    crypto/cipher/aes_icm_ossl.c
    crypto/cipher/aes_gcm_ossl.c
  )
elseif(ENABLE_MBEDTLS)
  list(APPEND CIPHERS_SOURCES_C
    crypto/cipher/aes_icm_mbedtls.c
    crypto/cipher/aes_gcm_mbedtls.c
  )
elseif(ENABLE_NSS)
  list(APPEND CIPHERS_SOURCES_C
    crypto/cipher/aes_icm_nss.c
    crypto/cipher/aes_gcm_nss.c
  )
else()
  list(APPEND CIPHERS_SOURCES_C
    crypto/cipher/aes.c
    crypto/cipher/aes_icm.c
  )
endif()

set(HASHES_SOURCES_C
  crypto/hash/auth.c
  crypto/hash/auth_test_cases.c
  crypto/hash/auth_test_cases.h
  crypto/hash/null_auth.c
)

if(ENABLE_OPENSSL)
  list(APPEND HASHES_SOURCES_C
    crypto/hash/hmac_ossl.c
  )
elseif(ENABLE_MBEDTLS)
  list(APPEND HASHES_SOURCES_C
    crypto/hash/hmac_mbedtls.c
  )
elseif(ENABLE_NSS)
  list(APPEND HASHES_SOURCES_C
    crypto/hash/hmac_nss.c
  )
else()
  list(APPEND HASHES_SOURCES_C
    crypto/hash/hmac.c
    crypto/hash/sha1.c
  )
endif()

set(KERNEL_SOURCES_C
  crypto/kernel/alloc.c
  crypto/kernel/crypto_kernel.c
  crypto/kernel/err.c
  crypto/kernel/key.c
)

set(MATH_SOURCES_C
  crypto/math/datatypes.c
)

set(REPLAY_SOURCES_C
  crypto/replay/rdb.c
  crypto/replay/rdbx.c
)

set(SOURCES_H
  crypto/include/aes.h
  crypto/include/aes_icm.h
  crypto/include/alloc.h
  crypto/include/auth.h
  crypto/include/cipher.h
  crypto/include/cipher_types.h
  crypto/include/crypto_kernel.h
  crypto/include/crypto_types.h
  crypto/include/datatypes.h
  crypto/include/err.h
  crypto/include/hmac.h
  crypto/include/integers.h
  crypto/include/key.h
  crypto/include/null_auth.h
  crypto/include/null_cipher.h
  crypto/include/rdb.h
  crypto/include/rdbx.h
  crypto/include/sha1.h
  include/srtp.h
  include/srtp_priv.h
  ${CONFIG_FILE_DIR}/config.h
)

if(BUILD_SHARED_LIBS AND WIN32)
  list(APPEND SOURCES_C
    srtp.def
  )
endif()

source_group("src" FILES ${SOURCES_C})
source_group("src\\Ciphers" FILES ${CIPHERS_SOURCES_C})
source_group("src\\Hashes" FILES ${HASHES_SOURCES_C})
source_group("src\\Kernel" FILES ${KERNEL_SOURCES_C})
source_group("src\\Math" FILES ${MATH_SOURCES_C})
source_group("src\\Replay" FILES ${REPLAY_SOURCES_C})
source_group("include" FILES ${SOURCES_H})

add_library(srtp2
  ${SOURCES_C}
  ${CIPHERS_SOURCES_C}
  ${HASHES_SOURCES_C}
  ${KERNEL_SOURCES_C}
  ${MATH_SOURCES_C}
  ${REPLAY_SOURCES_C}
  ${SOURCES_H}
)
add_library(libSRTP::srtp2 ALIAS srtp2)

set_target_properties(srtp2 PROPERTIES VERSION ${CMAKE_PROJECT_VERSION})

target_include_directories(srtp2 PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/crypto/include>
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
if(ENABLE_OPENSSL)
  target_include_directories(srtp2 PRIVATE ${OPENSSL_INCLUDE_DIR})
  target_link_libraries(srtp2 OpenSSL::Crypto)
elseif(ENABLE_MBEDTLS)
  target_include_directories(srtp2 PRIVATE ${MBEDTLS_INCLUDE_DIRS})
  target_link_libraries(srtp2 ${MBEDTLS_LIBRARIES})
elseif(ENABLE_NSS)
  target_include_directories(srtp2 PRIVATE ${NSS_INCLUDE_DIRS})
  target_link_libraries(srtp2 ${NSS_LIBRARIES})
endif()
if(WIN32)
  target_link_libraries(srtp2 ws2_32)
  target_compile_definitions(srtp2 PUBLIC _CRT_SECURE_NO_WARNINGS)
endif()

install(TARGETS srtp2 DESTINATION lib
  EXPORT libSRTPTargets
)

install(FILES include/srtp.h crypto/include/auth.h
  crypto/include/cipher.h
  crypto/include/crypto_types.h
  DESTINATION include/srtp2)

if(TEST_APPS)
  enable_testing()

  find_package(PCAP)
  if (PCAP_FOUND)
    add_executable(rtp_decoder test/rtp_decoder.c test/getopt_s.c test/util.c)
    target_link_libraries(rtp_decoder srtp2 ${PCAP_LIBRARY})
  endif()

  if(NOT (BUILD_SHARED_LIBS AND WIN32))
    if(NOT USE_EXTERNAL_CRYPTO)
      add_executable(aes_calc crypto/test/aes_calc.c test/getopt_s.c test/util.c)
      target_include_directories(aes_calc PRIVATE test)
      target_link_libraries(aes_calc srtp2)
      add_test(aes_calc_128 aes_calc 000102030405060708090a0b0c0d0e0f
                                     00112233445566778899aabbccddeeff
                                     69c4e0d86a7b0430d8cdb78070b4c55a)
      add_test(aes_calc_256 aes_calc 000102030405060708090a0b0c0d0e0f101112131415161718191a1b1c1d1e1f
                                     00112233445566778899aabbccddeeff
                                     8ea2b7ca516745bfeafc49904b496089)

      add_executable(sha1_driver crypto/test/sha1_driver.c test/util.c)
      target_include_directories(sha1_driver PRIVATE test)
      target_link_libraries(sha1_driver srtp2)
      add_test(sha1_driver sha1_driver -v)
    endif()

    add_executable(datatypes_driver crypto/test/datatypes_driver.c test/util.c)
    target_include_directories(datatypes_driver PRIVATE test)
    target_link_libraries(datatypes_driver srtp2)
    add_test(datatypes_driver datatypes_driver -v)

    add_executable(cipher_driver crypto/test/cipher_driver.c test/getopt_s.c)
    target_include_directories(cipher_driver PRIVATE test)
    target_link_libraries(cipher_driver srtp2)
    add_test(cipher_driver cipher_driver -v)

    add_executable(kernel_driver crypto/test/kernel_driver.c test/getopt_s.c)
    target_include_directories(kernel_driver PRIVATE test)
    target_link_libraries(kernel_driver srtp2)
    add_test(kernel_driver kernel_driver -v)

    add_executable(rdbx_driver test/rdbx_driver.c test/getopt_s.c test/ut_sim.c)
    target_include_directories(rdbx_driver PRIVATE test)
    target_link_libraries(rdbx_driver srtp2)
    add_test(rdbx_driver rdbx_driver -v)

    add_executable(replay_driver test/replay_driver.c test/ut_sim.c)
    target_include_directories(replay_driver PRIVATE test)
    target_link_libraries(replay_driver srtp2)
    add_test(replay_driver replay_driver -v)

    add_executable(roc_driver test/roc_driver.c test/ut_sim.c)
    target_include_directories(roc_driver PRIVATE test)
    target_link_libraries(roc_driver srtp2)
    add_test(roc_driver roc_driver -v)
  endif()

  add_executable(srtp_driver test/srtp_driver.c
    test/util.c test/getopt_s.c)
  target_link_libraries(srtp_driver srtp2)
  add_test(srtp_driver srtp_driver -v)

  if(NOT (BUILD_SHARED_LIBS AND WIN32))
    add_executable(test_srtp test/test_srtp.c)
    if(ENABLE_OPENSSL)
      target_include_directories(test_srtp PRIVATE ${OPENSSL_INCLUDE_DIR})
    elseif(ENABLE_MBEDTLS)
      target_include_directories(test_srtp PRIVATE ${MBEDTLS_INCLUDE_DIRS})
    elseif(ENABLE_NSS)
      target_include_directories(test_srtp PRIVATE ${NSS_INCLUDE_DIRS})
    endif()
    target_link_libraries(test_srtp srtp2)
    add_test(test_srtp test_srtp)
  endif()

  find_program(BASH_PROGRAM bash)
  if(BASH_PROGRAM AND NOT WIN32)
    add_executable(rtpw test/rtpw.c test/rtp.c test/util.c test/getopt_s.c)
    target_link_libraries(rtpw srtp2)
    add_test(NAME rtpw_test
             COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test/rtpw_test.sh -w ${CMAKE_CURRENT_SOURCE_DIR}/test/words.txt

=== debian/changelog ===
libsrtp2 (2.5.0-3) unstable; urgency=medium

  * update symbols:
    + 8 optional symbols dropped
    + 7 optional symbols added

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 05 Feb 2023 12:06:39 +0100

libsrtp2 (2.5.0-2) experimental; urgency=medium

  * fix separate arch and indep build routines

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 04 Feb 2023 18:05:40 +0100

libsrtp2 (2.5.0-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * drop patches cherry-picked upstream now applied
  * update and unfuzz patches
  * declare compliance with Debian Policy 4.6.2
  * update copyright info: update coverage
  * update git-buildpackage config:
    + use DEP-14 git branches
    + enable automatic DEP-14 branch name handling
    + add usage config
  * simplify build;
    build-depend dh-sequence-pkgkde-symbolshelper;
    stop build-depend on cdbs
  * use debhelper compatibility level 13 (not 10);
    build-depend on debhelper-compat (not debhelper)
  * stop provide binary package libsrtp2-1-dbg

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 04 Feb 2023 16:40:43 +0100

libsrtp2 (2.4.2-3) unstable; urgency=medium

  * add patches cherry-picked upstream:
    + count blocks instead of bytes in AES-ICM limit computation
    + cast time_t values to known types for formatting in fprintf;
      closes: bug#958427, thanks to Laurent Bigonville
    + avoid deprecated OpenSSL dunction EVP_CIPHER_CTX_cleanup()
  * update copyright info:
    + sort License sections alphabetically
    + drop superfluous secondary source URI
    + update coverage
  * tighten lintian overrides

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 07 Mar 2022 15:22:16 +0100

=== debian/control ===
Source: libsrtp2
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders:
 Jonas Smedegaard <dr@jones.dk>,
Build-Depends:
 d-shlibs (>= 0.91~),
 debhelper-compat (= 13),
 dh-sequence-pkgkde-symbolshelper,
 libnss3-dev,
 libpcap0.8-dev <!nocheck>,
 miscfiles,
 pkg-config,
 pkg-kde-tools,
 procps,
 psmisc,
Build-Depends-Indep:
 doxygen,
Standards-Version: 4.6.2
Section: libs
Vcs-Git: https://salsa.debian.org/pkg-voip-team/libsrtp2.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/libsrtp2.git
Homepage: https://github.com/cisco/libsrtp
Rules-Requires-Root: no

Package: libsrtp2-dev
Section: libdevel
Depends:
 libsrtp2-1 (= ${binary:Version}),
 pkg-config,
 ${devlibs:Depends},
 ${misc:Depends},
Suggests:
 libsrtp2-docs,
Architecture: any
Description: Secure RTP (SRTP) and UST Reference Implementations - development files
 SRTP is a security profile for RTP
 that adds confidentiality, message authentication, and replay protection
 to that protocol.
 It is specified in RFC 3711.
 .
 LibSRTP provides an implementation
 of the Secure Real-time Transport Protocol (SRTP),
 the Universal Security Transform (UST),
 and a supporting cryptographic kernel.
 .
 This package contains the development headers and static libraries.

Package: libsrtp2-1
Section: libs
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Architecture: any
Multi-Arch: same
Description: Secure RTP (SRTP) and UST Reference Implementations - shared library
 SRTP is a security profile for RTP
 that adds confidentiality, message authentication, and replay protection
 to that protocol.
 It is specified in RFC 3711.
 .
 LibSRTP provides an implementation
 of the Secure Real-time Transport Protocol (SRTP),
 the Universal Security Transform (UST),
 and a supporting cryptographic kernel.
 .
 This package contains the shared libraries.

Package: libsrtp2-docs
Section: doc
Depends:
 ${misc:Depends},
Architecture: all
Description: Secure RTP (SRTP) and UST Reference Implementations - documentation
 SRTP is a security profile for RTP that adds confidentiality, message
 authentication, and replay protection to that protocol. It is specified
 in RFC 3711.
 .
 LibSRTP provides an implementation
 of the Secure Real-time Transport Protocol (SRTP),
 the Universal Security Transform (UST),
 and a supporting cryptographic kernel.
 .
 This package contains API documentation.

=== debian/watch ===
version=4
# check: uscan --report
# update: gbp import-orig --upstream-vcs-tag=vX.Y.Z --uscan

opts=\
filenamemangle=s/.*?(@ANY_VERSION@@ARCHIVE_EXT@)/@PACKAGE@-$1/,\
dversionmangle=auto,repacksuffix=~dfsg \
https://github.com/cisco/libsrtp/tags \
.*?@ANY_VERSION@@ARCHIVE_EXT@

## libsrtp2 2.5.0-3+11.0trisquel1

=== debian/changelog ===
libsrtp2 (2.5.0-3+11.0trisquel1) aramo-backports; urgency=medium

  * Backported from debian bookworm as dependency of libtgwot for
    openssl 3.0 support.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 13 Dec 2023 07:59:32 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: libsrtp2
 Priority: optional
-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders:
  Jonas Smedegaard <dr@jones.dk>,
 Build-Depends:

## libsrtp2 2.6.0

=== debian/changelog ===
libsrtp2 (2.6.0-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * update symbols: 1 symbol dropped

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 04 Mar 2024 23:53:46 +0100

## libsrtp2 2.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,17 +1,42 @@
-cmake_minimum_required(VERSION 3.12)
-
-project(libsrtp2 VERSION 2.5.0 LANGUAGES C)
-
-set(PACKAGE_VERSION ${CMAKE_PROJECT_VERSION})
-set(PACKAGE_STRING "${CMAKE_PROJECT_NAME} ${CMAKE_PROJECT_VERSION}")
+cmake_minimum_required(VERSION 3.21)
+
+project(libsrtp2 VERSION 2.7.0 LANGUAGES C)
+
+set(CMAKE_C_STANDARD 99)
+set(CMAKE_C_STANDARD_REQUIRED ON)
+set(CMAKE_C_EXTENSIONS ON)
+set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
+
+set(PACKAGE_VERSION ${PROJECT_VERSION})
+set(PACKAGE_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
 
 list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
+
+
+option(ENABLE_WARNINGS "Enable to add warnings to a target." ON)
+option(ENABLE_WARNINGS_AS_ERRORS "Enable to treat warnings as errors." ON)
+
+option(ENABLE_SANITIZE_ADDR "Enable address sanitize." OFF)
+option(ENABLE_SANITIZE_UNDEF "Enable undefined sanitize." OFF)
+option(ENABLE_SANITIZE_LEAK "Enable leak sanitize (Gcc/Clang only)." OFF)
+option(ENABLE_SANITIZE_THREAD "Enable thread sanitize (Gcc/Clang only)." OFF)
+
+option(ENABLE_LTO "Enable to add Link Time Optimization." OFF)
+
+option(LIBSRTP_TEST_APPS "Build libSRTP test applications" ON)
+option(BUILD_SHARED_LIBS "Build shared library" OFF)
 
 include(TestBigEndian)
 include(CheckIncludeFile)
 include(CheckFunctionExists)
 include(CheckTypeSize)
 include(CheckCSourceCompiles)
+include(ConfigSafeGuards)
+
+if(ENABLE_WARNINGS)
+    include(Warnings)
+endif()
+
 
 test_big_endian(WORDS_BIGENDIAN)
 
@@ -59,10 +84,6 @@
 set(ENABLE_OPENSSL OFF CACHE BOOL "Enable OpenSSL crypto engine")
 set(ENABLE_MBEDTLS OFF CACHE BOOL "Enable MbedTLS crypto engine")
 set(ENABLE_NSS OFF CACHE BOOL "Enable NSS crypto engine")
-set(TEST_APPS ON CACHE BOOL "Build test applications")
-set(BUILD_WITH_SANITIZERS OFF CACHE BOOL "Adds sanitizer flags to compiler")
-set(BUILD_WITH_WARNINGS ON CACHE BOOL "Adds warnings and warning as error flags to compiler")
-option(BUILD_SHARED_LIBS "Build shared library" OFF)
 
 if(ENABLE_OPENSSL OR ENABLE_MBEDTLS OR ENABLE_NSS)
   set(USE_EXTERNAL_CRYPTO TRUE)
@@ -103,29 +124,13 @@
 configure_file(config_in_cmake.h ${CONFIG_FILE_DIR}/config.h)
 add_definitions(-DHAVE_CONFIG_H)
 
-if(BUILD_WITH_SANITIZERS AND NOT WIN32)
-  if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
-    set(SANITIZERS address,undefined)
-  else()
-    set(SANITIZERS leak,address,undefined)
-  endif()
-  message(STATUS "Using sanitizers: ${SANITIZERS}")
-  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
-  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
-  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
-  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
-  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fno-omit-frame-pointer -fsanitize=${SANITIZERS}")
-endif()
-
-
-if(BUILD_WITH_WARNINGS)
-  if(CMAKE_C_COMPILER_ID MATCHES "Clang" OR CMAKE_C_COMPILER_ID MATCHES "GNU")
-    set(WARNINGS -Wall -pedantic -Wextra -Werror)
-  elseif(MSVC)
-    set(WARNINGS /W4 /WX)
-  endif()
-  message(STATUS "Using warnings: ${WARNINGS}")
-  add_compile_options(${WARNINGS})
+if(ENABLE_SANITIZE_ADDR OR ENABLE_SANITIZE_UNDEF)
+    include(Sanitizer)
+    add_sanitizer_flags()
+endif()
+
+if(ENABLE_LTO)
+    include(LTO)
 endif()
 
 set(SOURCES_C
@@ -252,7 +257,26 @@
 )
 add_library(libSRTP::srtp2 ALIAS srtp2)
 
-set_target_properties(srtp2 PROPERTIES VERSION ${CMAKE_PROJECT_VERSION})
+if (${ENABLE_WARNINGS})
+    target_set_warnings(
+            TARGET
+            "srtp2"
+            ENABLE
+            ${ENABLE_WARNINGS}
+            AS_ERRORS
+            ${ENABLE_WARNINGS_AS_ERRORS})
+endif()
+
+if(${ENABLE_LTO})
+    target_enable_lto(
+            TARGET
+            "srtp2"
+            ENABLE
+            ON)
+endif()
+
+
+set_target_properties(srtp2 PROPERTIES VERSION ${PROJECT_VERSION})
 
 target_include_directories(srtp2 PUBLIC
   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/crypto/include>
@@ -283,7 +307,7 @@
   crypto/include/crypto_types.h
   DESTINATION include/srtp2)
 
-if(TEST_APPS)
+if(LIBSRTP_TEST_APPS)
   enable_testing()
 
   find_package(PCAP)
@@ -297,6 +321,13 @@
       add_executable(aes_calc crypto/test/aes_calc.c test/getopt_s.c test/util.c)
       target_include_directories(aes_calc PRIVATE test)
       target_link_libraries(aes_calc srtp2)
+      target_set_warnings(
+              TARGET
+              aes_calc
+              ENABLE
+              ${ENABLE_WARNINGS}
+              AS_ERRORS
+              ${ENABLE_WARNINGS_AS_ERRORS})
       add_test(aes_calc_128 aes_calc 000102030405060708090a0b0c0d0e0f
                                      00112233445566778899aabbccddeeff
                                      69c4e0d86a7b0430d8cdb78070b4c55a)
@@ -305,63 +336,72 @@
                                      8ea2b7ca516745bfeafc49904b496089)
 
       add_executable(sha1_driver crypto/test/sha1_driver.c test/util.c)
+      target_set_warnings(
+              TARGET
+              sha1_driver
+              ENABLE
+              ${ENABLE_WARNINGS}
+              AS_ERRORS
+              ${ENABLE_WARNINGS_AS_ERRORS})
       target_include_directories(sha1_driver PRIVATE test)
       target_link_libraries(sha1_driver srtp2)
       add_test(sha1_driver sha1_driver -v)
     endif()
 
     add_executable(datatypes_driver crypto/test/datatypes_driver.c test/util.c)
+    target_set_warnings(
+            TARGET
+            datatypes_driver
+            ENABLE
+            ${ENABLE_WARNINGS}
+            AS_ERRORS
+            ${ENABLE_WARNINGS_AS_ERRORS})
     target_include_directories(datatypes_driver PRIVATE test)
     target_link_libraries(datatypes_driver srtp2)
     add_test(datatypes_driver datatypes_driver -v)
 
     add_executable(cipher_driver crypto/test/cipher_driver.c test/getopt_s.c)
+    target_set_warnings(
+            TARGET
+            cipher_driver
+            ENABLE
+            ${ENABLE_WARNINGS}
+            AS_ERRORS
+            ${ENABLE_WARNINGS_AS_ERRORS})
     target_include_directories(cipher_driver PRIVATE test)
     target_link_libraries(cipher_driver srtp2)
     add_test(cipher_driver cipher_driver -v)
 
     add_executable(kernel_driver crypto/test/kernel_driver.c test/getopt_s.c)
+    target_set_warnings(
+            TARGET
+            kernel_driver
+            ENABLE
+            ${ENABLE_WARNINGS}
+            AS_ERRORS
+            ${ENABLE_WARNINGS_AS_ERRORS})
     target_include_directories(kernel_driver PRIVATE test)
     target_link_libraries(kernel_driver srtp2)
     add_test(kernel_driver kernel_driver -v)
 
     add_executable(rdbx_driver test/rdbx_driver.c test/getopt_s.c test/ut_sim.c)
+    target_set_warnings(
+            TARGET
+            rdbx_driver
+            ENABLE
+            ${ENABLE_WARNINGS}
+            AS_ERRORS
+            ${ENABLE_WARNINGS_AS_ERRORS})
     target_include_directories(rdbx_driver PRIVATE test)
     target_link_libraries(rdbx_driver srtp2)
     add_test(rdbx_driver rdbx_driver -v)
 
     add_executable(replay_driver test/replay_driver.c test/ut_sim.c)
+    target_set_warnings(
+            TARGET
+            replay_driver
+            ENABLE
+            ${ENABLE_WARNINGS}
+            AS_ERRORS
+            ${ENABLE_WARNINGS_AS_ERRORS})
     target_include_directories(replay_driver PRIVATE test)
-    target_link_libraries(replay_driver srtp2)
-    add_test(replay_driver replay_driver -v)
-
-    add_executable(roc_driver test/roc_driver.c test/ut_sim.c)
-    target_include_directories(roc_driver PRIVATE test)
-    target_link_libraries(roc_driver srtp2)
-    add_test(roc_driver roc_driver -v)
-  endif()
-
-  add_executable(srtp_driver test/srtp_driver.c
-    test/util.c test/getopt_s.c)
-  target_link_libraries(srtp_driver srtp2)
-  add_test(srtp_driver srtp_driver -v)
-
-  if(NOT (BUILD_SHARED_LIBS AND WIN32))
-    add_executable(test_srtp test/test_srtp.c)
-    if(ENABLE_OPENSSL)
-      target_include_directories(test_srtp PRIVATE ${OPENSSL_INCLUDE_DIR})
-    elseif(ENABLE_MBEDTLS)
-      target_include_directories(test_srtp PRIVATE ${MBEDTLS_INCLUDE_DIRS})
-    elseif(ENABLE_NSS)
-      target_include_directories(test_srtp PRIVATE ${NSS_INCLUDE_DIRS})
-    endif()
-    target_link_libraries(test_srtp srtp2)
-    add_test(test_srtp test_srtp)
-  endif()
-
-  find_program(BASH_PROGRAM bash)
-  if(BASH_PROGRAM AND NOT WIN32)
-    add_executable(rtpw test/rtpw.c test/rtp.c test/util.c test/getopt_s.c)
-    target_link_libraries(rtpw srtp2)
-    add_test(NAME rtpw_test
-             COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test/rtpw_test.sh -w ${CMAKE_CURRENT_SOURCE_DIR}/test/words.txt

=== meson_options.txt ===
option('debug-logging', type : 'boolean', value : false,
  description : 'Enable debug logging in all modules')
option('log-stdout', type : 'boolean', value : false,
  description : 'Redirect logging to stdout')
option('log-file', type : 'string', value : '',
  description : 'Write logging output into this file')
option('crypto-library', type: 'combo', choices : ['none', 'openssl', 'nss', 'mbedtls'], value : 'none',
  description : 'What external crypto library to leverage, if any (OpenSSL, NSS, or mbedtls)')
option('crypto-library-kdf', type : 'feature', value : 'auto',
  description : 'Use the external crypto library for Key Derivation Function support')
option('fuzzer', type : 'feature', value : 'disabled',
  description : 'Build libsrtp2 fuzzer (requires build with clang)')
option('tests', type : 'feature', value : 'auto', yield : true,
  description : 'Build test applications')
option('pcap-tests', type : 'feature', value : 'auto',
  description : 'Build test application that require libpcap')
option('doc', type : 'feature', value : 'auto', yield : true,
  description : 'Generate API documentation with doxygen')

=== debian/changelog ===
libsrtp2 (2.7.0-3) unstable; urgency=medium

  * no-changes source-only upload to enable testing migration

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 13 Apr 2025 15:18:22 +0200

libsrtp2 (2.7.0-2) experimental; urgency=medium

  [ Victor Seva ]
  * flag libsrtp2-docs as Multi-Arch: foreign

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 24 Mar 2025 14:30:57 +0100

libsrtp2 (2.7.0-1) experimental; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * declare compliance with Debian Policy 4.7.2
  * update copyright info: update coverage
  * update symbols: 1 optional symbol dropped

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 24 Mar 2025 14:24:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: libsrtp2
 Priority: optional
-Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
+Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
 Uploaders:
  Jonas Smedegaard <dr@jones.dk>,
 Build-Depends:
@@ -16,7 +16,7 @@
  psmisc,
 Build-Depends-Indep:
  doxygen,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Section: libs
 Vcs-Git: https://salsa.debian.org/pkg-voip-team/libsrtp2.git
 Vcs-Browser: https://salsa.debian.org/pkg-voip-team/libsrtp2.git
@@ -73,6 +73,7 @@
 Depends:
  ${misc:Depends},
 Architecture: all
+Multi-Arch: foreign
 Description: Secure RTP (SRTP) and UST Reference Implementations - documentation
  SRTP is a security profile for RTP that adds confidentiality, message
  authentication, and replay protection to that protocol. It is specified

=== debian/rules ===
#!/usr/bin/make -f

CONFIGURE_OPTS = --disable-stdout --enable-syslog
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
CONFIGURE_OPTS += --enable-debug
else
CONFIGURE_OPTS += --disable-debug
endif

CONFIGURE_OPTS += --enable-nss

DEB_CFLAGS_MAINT_APPEND = -D_REENTRANT

ifeq ($(DEB_HOST_ARCH_CPU),sparc)
DEB_CFLAGS_MAINT_APPEND += -DFORCE_64BIT_ALIGN
endif

# Reapply default strong optimizations unless noopt in DEB_BUILD_OPTIONS
ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
DEB_CFLAGS_MAINT_STRIP = -O2
DEB_CFLAGS_MAINT_APPEND += -O4 -fexpensive-optimizations -funroll-loops
endif

export DEB_CFLAGS_MAINT_APPEND

%:
	dh $@

# TODO: stop suppress when understood how to tame dh_autoreconf
override_dh_autoreconf:

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_OPTS)

override_dh_auto_build-arch:
	dh_auto_build -- shared_library test

override_dh_auto_build-indep:
	dh_auto_build -- libsrtp2doc

# Ensure test script is executable
execute_before_dh_auto_test:
	chmod +x test/rtpw_test.sh

override_dh_auto_test-arch:
	LD_LIBRARY_PATH="${LD_LIBRARY_PATH}:$(realpath .)" dh_auto_test -- runtest

override_dh_auto_test-indep:

override_dh_auto_install-indep:

# Let d-shlibs calculate development package dependencies
#  and handle shared library install
execute_after_dh_install-arch:
	d-shlibmove --commit \
		--devunversioned \
		--multiarch \
		--movedev "debian/tmp/usr/include/*" usr/include/ \
		--movedev "debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/*" \
			usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/*.so

override_dh_strip:
	dh_strip --dbgsym-migration='libsrtp2-1-dbg (<< 2.5.0-1~)'

override_dh_auto_clean:
	dh_auto_clean -- superclean
